//====================================================================
// File Name : option.h
// Function  : S3C2410 
// Program   : Shin, On Pil (SOP)
// Date      : March 4, 2002
// Version   : 0.0
// History
//   0.0 : Programming start (February 20,2002) -> SOP
//====================================================================

#ifndef __OPTION_H__
#define __OPTION_H__

#if 1
#define FCLK 200000000
#define HCLK FCLK/2
#define PCLK HCLK/2
#else
#define FCLK 180000000
#define HCLK (FCLK/2)
#define PCLK (HCLK/2)
#define UCLK 48000000
#endif

// BUSWIDTH : 16,32
#define BUSWIDTH    (32)

//64MB
// 0x30000000 ~ 0x30ffffff : Download Area (16MB) Cacheable
// 0x31000000 ~ 0x33feffff : Non-Cacheable Area
// 0x33ff0000 ~ 0x33ff47ff : Heap & RW Area
// 0x33ff4800 ~ 0x33ff7fff : FIQ ~ User Stack Area
// 0x33ff8000 ~ 0x33fffeff : Not Useed Area
// 0x33ffff00 ~ 0x33ffffff : Exception & ISR Vector Table

#define _RAM_STARTADDRESS 	0x30000000
#define _NONCACHE_STARTADDRESS	0x31000000
#define _ISR_STARTADDRESS 	0x33ffff00     
#define _MMUTT_STARTADDRESS	0x33ff8000
#define _STACK_BASEADDRESS  0x33ff8000
#define HEAPEND		  		0x33ff0000

//If you use ADS1.x, please define ADS10
#define ADS10 FALSE

//USB Device Options
#define USBDMA		TRUE
#define USBDMA_DEMAND 	FALSE	//the downloadFileSize should be (64*n)
#define BULK_PKT_SIZE	32


#define DOWN_KERNEL	1
#define DOWN_LOADER	2
#define DOWN_KERNEL_START_BLOCK	5
//#define DOWN_KERNEL_SIZE	0x2000000
#define DOWN_LOADER_START_BLOCK	0
//#define DOWN_LOADER_SIZE	(DOWN_KERNEL_BLOCK*32*512)
#define DOWN_RAM_ADDR		(0x30100000)

// note: makefile,option.a should be changed

#endif /*__OPTION_H__*/